import nltk, re, pprint

lp = nltk.LogicParser()
lp.parse('-(p & q)')

lp.parse('p & q')

lp.parse('p | (r -> q)')

lp.parse('p <-> -- p')

val1 = nltk.sem.Valuation([('p', True), ('q', True), ('r', False)])

val1['p']

val1.symbols

dom1 = set([])
g = nltk.sem.Assignment(dom1)

m1 = nltk.sem.Model(dom1, val1, prop=True)

m1.AND

for first in [True, False]:
    for second in [True, False]:
        print "%s %s => %s" % (first, second, m1.AND(first, second))

parsed = lp.parse('see(a, b)')
parsed.argument

parsed.function

parsed.function.function

dom2 = set(['b1', 'g1', 'd1'])

v = [('adam','b1'),('betty','g1'),('fido','d1'),
('boy',set(['b1'])),('girl',set(['g1'])), ('dog',set(['d1'])),
('walk',set(['g1', 'd1'])),
('see', set([('b1','g1'),('d1','b1'),('g1','d1'),]))]
val2 = nltk.sem.Valuation(v)
print val2

from nltk.sem import app
boy = val2['boy']
app(boy, 'b1')

app(boy, 'g1')

see = val2['see']
app(see, 'g1')

app(app(see, 'g1'), 'd1')

g = nltk.sem.Assignment(dom2, [('x', 'b1'), ('y', 'd1')])
g

print g

m2 = nltk.sem.Model(dom2, val2)
m2.evaluate('see(betty, y)', g)

g['y']

m2.evaluate('see(x, y)', g)

g.purge()
g

m2.evaluate('see(adam, y)', g)

m2.evaluate('some x.(girl(x) & walk(x))', g)

m2.evaluate('girl(x) & walk(x)', g.add('x', 'g1'))

fmla1 = lp.parse('girl(x) | boy(x)')
m2.satisfiers(fmla1, 'x', g)

fmla2 = lp.parse('girl(x) -> walk(x)')
m2.satisfiers(fmla2, 'x', g)

fmla3 = lp.parse('walk(x) -> girl(x)')
m2.satisfiers(fmla3, 'x', g)

for first in [True, False]:
    for second in [True, False]:
        print "%s %s => %s" % (first, second, m2.IMPLIES(first, second))

m2.evaluate('all x.(girl(x) -> walk(x))', g)

v3 = [('john', 'b1'),
('mary', 'g1'),
('suzie', 'g2'),
('fido', 'd1'),
('tess', 'd2'),
('noosa', 'n'),
('girl', set(['g1', 'g2'])),
('boy', set(['b1', 'b2'])),
('dog', set(['d1', 'd2'])),
('bark', set(['d1', 'd2'])),
('walk', set(['b1', 'g2', 'd1'])),
('chase', set([('b1', 'g1'), ('b2', 'g1'), ('g1', 'd1'), ('g2', 'd2')])),
('see', set([('b1', 'g1'), ('b2', 'd2'), ('g1', 'b1'),
('d2', 'b1'), ('g2', 'n')])),
('in', set([('b1', 'n'), ('b2', 'n'), ('d2', 'n')])),
('with', set([('b1', 'g1'), ('g1', 'b1'), ('d1', 'b1'), ('b1', 'd1')]))]
val3 = nltk.sem.Valuation(v3)

dom3 = val3.domain
m3 = nltk.sem.Model(dom3, val3)
g = nltk.sem.Assignment(dom3)
fmla1 = lp.parse('(girl(x) -> exists y.(dog(y) and chase(x, y)))')
m3.satisfiers(fmla1, 'x', g)



fmla2 = lp.parse('(dog(y) & all x.(girl(x) -> chase(x, y)))')
m3.satisfiers(fmla2, 'y', g)



fmla3 = lp.parse('(girl(y) & all x.(boy(x) -> chase(x, y)))')
m3.satisfiers(fmla3, 'y', g)

grammar = nltk.data.load('grammars/sem1.fcfg')
result  = nltk.sem.text_interpret(['a dog barks'], grammar, beta_reduce=0)
(syntree, semrep) = result['a dog barks'][0]
print syntree

print semrep.simplify()

grammar = nltk.data.load('grammars/sem2.fcfg')
val4 = nltk.data.load('grammars/valuation1.val')
dom4 = val4.domain
m4 = nltk.sem.Model(dom4, val4)
g = nltk.sem.Assignment(dom4)
sent = 'every boy chases a girl in Noosa'
result = nltk.sem.text_evaluate([sent], grammar, m4, g)
for (syntree, semrep, value) in result[sent]:
	print "'%s' is %s in Model m\n" % (semrep, value)

from nltk.corpus import chat80
chat80.items # doctest: +ELLIPSIS

concepts = chat80.concepts('city')
concepts

rel = concepts[1].extension
list(rel)[:5]

val = nltk.corpus.chat80.make_valuation(concepts, read=True)
val['city']['calcutta']

val['country_of']['india']

dom = val.domain
g = nltk.sem.Assignment(dom)
m = nltk.sem.Model(dom, val)
m.evaluate(r'\x .population_of(jakarta, x)', g)

